{ SMReport Designer

  Copyright (C) 1998-2002, written by Mike Shkolnik, Scalabium
  E-Mail:  smreport@scalabium.com
           mshkolnik@scalabium.com
           mshkolnik@yahoo.com
  WEB: http://www.scalabium.com
       http://www.geocities.com/mshkolnik
  tel: 380-/44/-552-10-29


  In this unit I describe a form for
  custom TSMRCheckBox component
}
unit SMRChEd;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, SMPWhen;

type
  TfrmEditCheck = class(TForm)
    bvlButton: TBevel;
    btnOk: TButton;
    btnCancel: TButton;
    pcElement: TPageControl;
    tsGeneral: TTabSheet;
    rgPosition: TRadioGroup;
    cbTransparent: TCheckBox;
    btnPrintWhen: TButton;
    gbSource: TGroupBox;
    rbValue: TRadioButton;
    rbField: TRadioButton;
    tsComment: TTabSheet;
    memoComment: TMemo;
    cbState: TComboBox;
    cbExpression: TComboBox;
    lblStyle: TLabel;
    cbStyle: TComboBox;
    procedure rbValueClick(Sender: TObject);
    procedure rbFieldClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure btnPrintWhenClick(Sender: TObject);
    procedure cbStateClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    PrintWhen: TSMPrintWhen;
    frmPrintWhen: TfrmPrintWhen;

    LangShift: LongInt;

    procedure FillStringsFromRes; 
  end;

implementation
uses SMRCnst, SMRUtils;
{$R *.DFM}

procedure TfrmEditCheck.rbValueClick(Sender: TObject);
begin
  cbState.Enabled := True;
  cbExpression.Enabled := False;
end;

procedure TfrmEditCheck.rbFieldClick(Sender: TObject);
begin
  cbState.Enabled := False;
  cbExpression.Enabled := True;
end;

procedure TfrmEditCheck.FormCreate(Sender: TObject);
begin
  frmPrintWhen := TfrmPrintWhen.Create(Self);
  cbStyle.ItemIndex := 0;
end;

procedure TfrmEditCheck.FormDestroy(Sender: TObject);
begin
  frmPrintWhen.Free;
end;

procedure TfrmEditCheck.FillStringsFromRes;
const
  smrcCheckStyle = 2503;
  smrcCheckStandard = 2504;
  smrcCheckCheck = 2505;
  smrcCheckCross = 2506;
begin
  Caption := GetString(LangShift, smrcCntrlCaption);
  tsGeneral.Caption := GetString(LangShift, smrcCntrlTsGeneral);
  tsComment.Caption := GetString(LangShift, smrcCntrlTsComment);

  rgPosition.Caption := GetString(LangShift, smrcCntrlRgPosition);
  rgPosition.Items[0] := GetString(LangShift, smrcCntrlRgPosition0);
  rgPosition.Items[1] := GetString(LangShift, smrcCntrlRgPosition1);
  rgPosition.Items[2] := GetString(LangShift, smrcCntrlRgPosition2);
  rgPosition.Items[3] := GetString(LangShift, smrcCntrlRgPosition3);

  cbTransparent.Caption := GetString(LangShift, smrcCntrlCbTransparent);
  btnPrintWhen.Caption := GetString(LangShift, smrcCntrlBtnPrintWhen);

  btnOk.Caption := GetString(LangShift, smrcCntrlBtnOk);
  btnCancel.Caption := GetString(LangShift, smrcCntrlBtnCancel);

  gbSource.Caption := GetString(LangShift, smrcImageGbSource);
  rbField.Caption := GetString(LangShift, smrcImageRbField);

  rbValue.Caption := GetString(LangShift, smrcImageRbConst);
  lblStyle.Caption := GetString(LangShift, smrcCheckStyle);
  cbStyle.Items[0] := GetString(LangShift, smrcCheckStandard);
  cbStyle.Items[1] := GetString(LangShift, smrcCheckCheck);
  cbStyle.Items[2] := GetString(LangShift, smrcCheckCross);
end;

procedure TfrmEditCheck.btnPrintWhenClick(Sender: TObject);
begin
  with frmPrintWhen do
    try
      LangShift := Self.LangShift;
      PWhen.Assign(PrintWhen);
      if (ShowModal = mrOk) then
        PrintWhen.Assign(PWhen);
    finally
    end;
end;

procedure TfrmEditCheck.cbStateClick(Sender: TObject);
begin
  rbValue.Checked := True
end;

end.
