unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, DBGrids, Db, DBTables, SMRTypes, SMRDMan;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    Table1: TTable;
    DBGrid1: TDBGrid;
    Label1: TLabel;
    edExpression: TEdit;
    btnExpressionBuilder: TButton;
    btnEvaluate: TButton;
    procedure btnExpressionBuilderClick(Sender: TObject);
    procedure btnEvaluateClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    DataManager: TSMRDataManager;
    lstVariables: TSMRVariables;

    procedure GetSMRVariableEvent(Sender: TObject; VariableName: string;
                                var Accept: Boolean;
                                var VariableType: TFieldType;
                                var Value: Variant);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
uses SMData, SMRPars;

procedure TForm1.btnExpressionBuilderClick(Sender: TObject);
var
  s: string;
begin
  s := edExpression.Text;
  if ExpressionBuilder(s, 0, DataManager, lstVariables) then
    edExpression.Text := s;
end;

procedure TForm1.btnEvaluateClick(Sender: TObject);
var
  Value: Variant;
begin
  Value := EvaluateValue(DataManager,
                         edExpression.Text,
                         GetSMRVariableEvent);
  ShowMessage('Calculated value is '#13#10#13#10 + VarToStr(Value))
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  DataManager.Free;
  lstVariables.Free;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  {fill a list of available dataset that you want to display for end-user}
  DataManager := TSMRDataManager.Create(nil);
  DataManager.FillDatasetList(Self, Table1);

  {fill a list of custom variables that you want to use}
  lstVariables := TSMRVariables.Create(nil);
  with lstVariables.Add do
  begin
    Name := 'Var1';
    Expression := 'My custom variable';
  end;
end;

{event where you may return value for any custom variable}
procedure TForm1.GetSMRVariableEvent(Sender: TObject; VariableName: string;
                                var Accept: Boolean;
                                var VariableType: TFieldType;
                                var Value: Variant);
begin
  if (VariableName = 'Var1') then
  begin
    Accept := True;
    VariableType := ftString;
    Value := 'Any string is here';
  end
end;

end.
