unit ManyGrp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  child, Db, DBTables, Grids, DBGrids, StdCtrls, PrintSM, SMRAuto, SMRBase,
  ComCtrls;

type
  TfrmManyGrp = class(TfrmChildParent)
    tcDataView: TTabControl;
    tvData: TTreeView;
    qryExample4: TQuery;
    ImageList: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure tcDataViewChange(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
    IsFirstActive: Boolean;
  public
    { Public declarations }
    procedure FillTreeView;
  end;

implementation

{$R *.DFM}

procedure TfrmManyGrp.FormCreate(Sender: TObject);
begin
  inherited;

  SMReport.LoadReport(ExtractFilePath(Application.ExeName) + '\ManyGrp.SMR');
  IsFirstActive := True
end;

procedure TfrmManyGrp.tcDataViewChange(Sender: TObject);
begin
  inherited;

  DBGrid.Visible := (tcDataView.TabIndex = 0);
  tvData.Visible := not DBGrid.Visible;

  if tvData.Visible and (tvData.Items.Count = 0) then
    FillTreeView;
end;

procedure TfrmManyGrp.FillTreeView;
var idCustNo, idOrderNo: Integer;
    itemCustomer, itemOrder: TTreeNode;
begin
  Screen.Cursor := crHourglass;
  with qryExample4 do
  begin
    idCustNo := -1;
    First;
    while not Eof do
    begin
      if (idCustNo <> FieldByName('CustNo').AsInteger) then
      begin
        {add a node for customer name}
        idCustNo := FieldByName('CustNo').AsInteger;
        itemCustomer := tvData.Items.Add(nil, 'Customer: #' +
                                              IntToStr(idCustNo) + ',  ' +
                                              FieldByName('Company').AsString + ', ' +
                                              FieldByName('Contact').AsString + ', ph: ' +
                                              FieldByName('Phone').AsString);
        itemCustomer.ImageIndex := 0;
        itemCustomer.SelectedIndex := 0;

        {set a bold style for item}
        SetNodeBold(itemCustomer);

        itemOrder := nil;
      end;

      if (idOrderNo <> FieldByName('OrderNo').AsInteger) or
         (itemOrder = nil) then
      begin
        idOrderNo := FieldByName('OrderNo').AsInteger;
        itemOrder := tvData.Items.AddChild(itemCustomer, 'Order: #' +
                                                         IntToStr(idOrderNo) + ',  ' +
                                                         FieldByName('SaleDate').AsString + ',  ' +
                                                         FloatToStrF(FieldByName('AmountPaid').AsFloat, ffCurrency, 18, 2));
        itemOrder.ImageIndex := 1;
        itemOrder.SelectedIndex := 1;
      end;

      with tvData.Items.AddChild(itemOrder, 'Part: #' +
                                            FieldByName('PartNo').AsString + ',  ' +
                                            FieldByName('Description').AsString + ',  ' +
                                            FloatToStrF(FieldByName('ListPrice').AsFloat, ffCurrency, 18, 2) + ' * ' +
                                            FieldByName('Qty').AsString + ' = ' +
                                            FloatToStrF(FieldByName('TOTAL').AsFloat, ffCurrency, 18, 2)) do
      begin
        ImageIndex := 2;
        SelectedIndex := 2;
      end;

      Next;
    end;
    First
  end;
  Screen.Cursor := crDefault;
end;

procedure TfrmManyGrp.FormActivate(Sender: TObject);
begin
  inherited;

  if IsFirstActive then
  begin
    IsFirstActive := False;

    ShowMessage('Don''t forget to press a TSMPrintData button on toolbar!'#13#13+
                'In this mode you can see the autogenerated report from DBGrid data with'#13+
                'column order, layout (width, alignments, fonts etc).'#13#13+
                'Also you can see a new features - "on-fly" grouping and calculations'#13+
                '(totals by items for each orders of any customer)!')
  end;
end;


end.
